EditPane (jEdit API Documentation)
Date: 2015-02-03

org.gjt.sp.jedit

## Class EditPane

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - org.gjt.sp.jedit.EditPane

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, BufferSetListener

      public class EditPane
      extends javax.swing.JPanel
      implements BufferSetListener

  A panel containing a text area.

  In a BeanShell script, you can obtain the current edit pane from the `editPane` variable.

  Each View can have multiple editPanes, one is active at a time. Each EditPane has a single JEditTextArea, and is operating on single buffer. The EditPane also can switch buffers. This is the "controller" between a JEditTextArea (view) and a buffer (model). This class does not have a public constructor. Edit panes can be created and destroyed using methods in the `View` class.

  See Also:
    `View.splitHorizontally()`, `View.splitVertically()`, `View.unsplitCurrent()`, `View.unsplit()`, `View.getEditPane()`, `View.getEditPanes()`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JComponent

      `accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addMarker()` Adds a marker at the caret position.
    `void` | `bufferAdded(Buffer buffer, int index)` A buffer was added in the bufferSet.
    `void` | `bufferMoved(Buffer buffer, int oldIndex, int newIndex)` A buffer was moved in the BufferSet.
    `void` | `bufferRemoved(Buffer buffer, int index)` A buffer was removed from the bufferSet.
    `void` | `bufferSetSorted()` The bufferSet was sorted
    `void` | `focusBufferSwitcher()` Pops up and focuses on the buffer switcher combo box.
    `void` | `focusOnTextArea()` Sets the focus onto the text area.
    `static EditPane` | `get(TextArea ta)` Returns the EditPane of a TextArea.
    `Buffer` | `getBuffer()` Returns the current buffer.
    `BufferSet` | `getBufferSet()` Returns the current buffer set.
    `BufferSwitcher` | `getBufferSwitcher()` Returns the buffer switcher combo box instance.
    `java.awt.Dimension` | `getMinimumSize()` Returns 0,0 for split pane compatibility.
    `JEditTextArea` | `getTextArea()` Returns the view's text area.
    `View` | `getView()` Returns the view containing this edit pane.
    `void` | `goToMarker(char shortcut, boolean select)` Moves the caret to the marker with the specified shortcut.
    `void` | `goToNextMarker(boolean select)` Moves the caret to the next marker.
    `void` | `goToPrevMarker(boolean select)` Moves the caret to the previous marker.
    `void` | `handleBufferUpdate(BufferUpdate msg)`
    `void` | `handlePropertiesChanged(PropertiesChanged msg)`
    `static void` | `initPainter(TextAreaPainter painter)` Init the painter of a textarea.
    `void` | `loadCaretInfo()` Loads the caret and selection information from this EditPane, fall back to the information from the current buffer if none is already in this EditPane.
    `void` | `nextBuffer()` Selects the next buffer.
    `void` | `prevBuffer()` Selects the previous buffer.
    `void` | `recentBuffer()` Selects the most recently edited buffer.
    `void` | `saveCaretInfo()` Saves the caret information to the current buffer.
    `void` | `setBuffer(Buffer buffer)` Sets the current buffer.
    `void` | `setBuffer(Buffer buffer, boolean requestFocus)` Sets the current buffer.
    `void` | `swapMarkerAndCaret(char shortcut)` Moves the caret to the marker with the specified shortcut, then sets the marker position to the former caret position.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### getView

          public View getView()

      Returns the view containing this edit pane.
      Returns:
        the view that contains this EditPane
      Since:
        jEdit 2.5pre2

    - #### get

          public static EditPane get(TextArea ta)

      Returns the EditPane of a TextArea.
      Parameters:
        `ta` - the textArea
      Returns:
        the EditPane containing the TextArea.

    - #### getBuffer

          public Buffer getBuffer()

      Returns the current buffer.
      Returns:
        the current buffer
      Since:
        jEdit 2.5pre2

    - #### setBuffer

          public void setBuffer(@Nonnull
                       Buffer buffer)

      Sets the current buffer.
      Parameters:
        `buffer` - The buffer to edit.
      Since:
        jEdit 2.5pre2

    - #### setBuffer

          public void setBuffer(@Nonnull
                       Buffer buffer,
                       boolean requestFocus)

      Sets the current buffer.
      Parameters:
        `buffer` - The buffer to edit.
        `requestFocus` - true if the textarea should request focus, false otherwise
      Since:
        jEdit 4.3pre6

    - #### prevBuffer

          public void prevBuffer()

      Selects the previous buffer.
      Since:
        jEdit 2.7pre2

    - #### nextBuffer

          public void nextBuffer()

      Selects the next buffer.
      Since:
        jEdit 2.7pre2

    - #### recentBuffer

          public void recentBuffer()

      Selects the most recently edited buffer.
      Since:
        jEdit 2.7pre2

    - #### focusOnTextArea

          public void focusOnTextArea()

      Sets the focus onto the text area.
      Since:
        jEdit 2.5pre2

    - #### getTextArea

          public JEditTextArea getTextArea()

      Returns the view's text area.
      Returns:
        the text area of the edit pane
      Since:
        jEdit 2.5pre2

    - #### getBufferSwitcher

          public BufferSwitcher getBufferSwitcher()

      Returns the buffer switcher combo box instance.
      Returns:
        the buffer switcher (it can be null)
      Since:
        jEdit 4.1pre8

    - #### focusBufferSwitcher

          public void focusBufferSwitcher()

      Pops up and focuses on the buffer switcher combo box.
      Since:
        jEdit 4.3pre18 (previously known as showBufferSwitcher)

    - #### saveCaretInfo

          public void saveCaretInfo()

      Saves the caret information to the current buffer.
      Since:
        jEdit 2.5pre2

    - #### loadCaretInfo

          public void loadCaretInfo()

      Loads the caret and selection information from this EditPane, fall back to the information from the current buffer if none is already in this EditPane.
      Since:
        jEdit 2.5pre2

    - #### goToNextMarker

          public void goToNextMarker(boolean select)

      Moves the caret to the next marker.
      Since:
        jEdit 4.3pre3

    - #### goToPrevMarker

          public void goToPrevMarker(boolean select)

      Moves the caret to the previous marker.
      Since:
        jEdit 2.7pre2

    - #### goToMarker

          public void goToMarker(char shortcut,
                        boolean select)

      Moves the caret to the marker with the specified shortcut.
      Parameters:
        `shortcut` - The shortcut
        `select` - True if the selection should be extended, false otherwise
      Since:
        jEdit 3.2pre2

    - #### addMarker

          public void addMarker()

      Adds a marker at the caret position.
      Since:
        jEdit 3.2pre1

    - #### swapMarkerAndCaret

          public void swapMarkerAndCaret(char shortcut)

      Moves the caret to the marker with the specified shortcut, then sets the marker position to the former caret position.
      Parameters:
        `shortcut` - The shortcut
      Since:
        jEdit 3.2pre2

    - #### handlePropertiesChanged

          public void handlePropertiesChanged(PropertiesChanged msg)

    - #### getMinimumSize

          public final java.awt.Dimension getMinimumSize()

      Returns 0,0 for split pane compatibility.
      Overrides:
        `getMinimumSize` in class `javax.swing.JComponent`

    - #### getBufferSet

          public BufferSet getBufferSet()

      Returns the current buffer set. This can be changed by setBufferSetScope().
      Returns:
        the buffer set which is currently used by this EditPane
      Since:
        jEdit 4.3pre17

    - #### bufferAdded

          public void bufferAdded(Buffer buffer,
                         int index)

      A buffer was added in the bufferSet.
      Specified by:
        `bufferAdded` in interface `BufferSetListener`
      Parameters:
        `buffer` - the added buffer
        `index` - the position where it was added
      Since:
        jEdit 4.3pre15

    - #### bufferRemoved

          public void bufferRemoved(Buffer buffer,
                           int index)

      A buffer was removed from the bufferSet.
      Specified by:
        `bufferRemoved` in interface `BufferSetListener`
      Parameters:
        `buffer` - the removed buffer
        `index` - the position where it was before being removed
      Since:
        jEdit 4.3pre15

    - #### bufferMoved

          public void bufferMoved(Buffer buffer,
                         int oldIndex,
                         int newIndex)

      A buffer was moved in the BufferSet.
      Specified by:
        `bufferMoved` in interface `BufferSetListener`
      Parameters:
        `buffer` - the moved buffer
        `oldIndex` - the position it was before
        `newIndex` - the new position
      Since:
        jEdit 4.3pre15

    - #### bufferSetSorted

          public void bufferSetSorted()

      The bufferSet was sorted
      Specified by:
        `bufferSetSorted` in interface `BufferSetListener`
      Since:
        jEdit 4.3pre16

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.awt.Component`

    - #### initPainter

          public static void initPainter(TextAreaPainter painter)

      Init the painter of a textarea.
      Parameters:
        `painter` - the painter of a textarea
      Since:
        jEdit 4.3pre12

    - #### handleBufferUpdate

          public void handleBufferUpdate(BufferUpdate msg)